<?php
$client = new SoapClient("http://127.0.0.1:34012/?wsdl", array("trace" => 1));

// Авторизация
$request = array(
    "login" => "admin",
    "pass" => "",
);
$response = $client->__soapCall("Login", array($request));
var_dump($response);

// добавить агента
$request = array(
    "isInsert" => 1,
    "val" => array(
        "agent" => array(
            "descr" => "agent example",
            "type" => 4,
            "id" => 0,
        ),
    ),
);
$response = $client->__soapCall("insupdAgent", array($request));
var_dump($response);
$agentid = $response->ret;

// добавить пользователя
$request = array(
    "isInsert" => 1,
    "val" => array(
        "account" => array(
            "uid" => 0,
            "type" => 2,
            "login" => "acc" . uniqid(),
            "pass" => "acc",
            "name" => "acc example",
        ),
    ),
);
$response = $client->__soapCall("insupdAccount", array($request));
var_dump($response);
$accid = $response->ret;

// добавить договор
$request = array(
    "isInsert" => 1,
    "val" => array(
        "uid" => $accid, 
        "number" => "agrm" . uniqid(), 
        "agrmid" => 0, 
        "operid" => 0,
        "curid" => 0,
    ),
);
$response = $client->__soapCall("insupdAgreement", array($request));
var_dump($response);
$agrmid = $response->ret;

// добавить учётную запись
$request = array(
    "isInsert" => 1,
    "val" => array(
        "vgroup" => array( 
            "agrmid" => $agrmid, 
            "id" => $agentid,
            "uid" => $accid,
            "vgid" => 0,
        ),
    ),
);
$response = $client->__soapCall("insupdVgroup", array($request));
var_dump($response);
$vgid = $response->ret;

// получить договор
$request = array(
    "flt" => array(
        "agrmid" => $agrmid,
    ),
);
$response = $client->__soapCall("getAgreements", array($request));
var_dump($response);

// получить учётные записи по договору
$response = $client->__soapCall("getVgroups", array($request));
var_dump($response);

// обновить данные учётной записи (описание)
$request = array(
    "isInsert" => 1,
    "val" => array(
        "vgroup" => array( 
            "agrmid" => $agrmid, 
            "id" => $agentid,
            "uid" => $accid,
            "vgid" => $vgid,
            "descr" => "updated vgroup data",
        ),
    ),
);
$response = $client->__soapCall("insupdVgroup", array($request));
var_dump($response);
$vgid = $response->ret;

// получить учётную запись по идентификатору
$request = array(
    "flt" => array(
        "vgid" => $vgid,
    ),
);
$response = $client->__soapCall("getVgroups", array($request));
var_dump($response);

# задать курс
$request = array(
    "val" => array(
        "curid" => "0",
        "rate" => "20.0",
        "date" => date("Y-m-d", time()),
    ),
);
$response = $client->__soapCall("updCurrencyRate", array($request));
var_dump($response);
$curid = $response->ret;

# платёж
$request = array(
    "val" => array(
        "agrmid" => $agrmid,
        "amount" => "200.0",
        "receipt" => "rec" . uniqid(),
        "comment" => "test payment",
        "curid" => $curid,
    ),
);
$response = $client->__soapCall("Payment", array($request));
var_dump($response);
$paymentid = $response->ret;

# получить информацию о платеже
$request = array(
    "flt" => array(
        "recordid" => $paymentid,
    ),
);
$response = $client->__soapCall("getPayments", array($request));
var_dump($response);

// удалить учётную запись
$request = array(
    "id" => $vgid,
);
$response = $client->__soapCall("delVgroup", array($request));
var_dump($response);

// закрыть договор
$request = array(
    "agrmid" => $agrmid,
    "closedate" => date("Y-m-d", time()),
);
$response = $client->__soapCall("closeAgreement", array($request));
var_dump($response);

// удалить договор
$request = array(
    "agrmid" => $agrmid,
);
$response = $client->__soapCall("delAgreement", array($request));
var_dump($response);

// удалить пользователя
$request = array(
    "id" => $accid,
);
$response = $client->__soapCall("delAccount", array($request));
var_dump($response);

// удалить агента
$request = array(
    "id" => $agentid,
);
$response = $client->__soapCall("delAgent", array($request));
var_dump($response);

$response = $client->__soapCall("Logout", array());
var_dump($response);
?>
